#define ICEIL(dividend, divisor) (((dividend) + ((divisor) - 1)) / (divisor))



//RGB class for BMP OS2 format
class RGBTRIPLE{
 public:
  unsigned char rgbBlue;
  unsigned char rgbGreen;
  unsigned char rgbRed;
  
  RGBTRIPLE(FILE *fp){
    size_t tmpsize_t = fread(&rgbBlue,1,1,fp);
    tmpsize_t = fread(&rgbGreen,1,1,fp);
    tmpsize_t = fread(&rgbRed,1,1,fp);
    
  }
  RGBTRIPLE(unsigned char r,unsigned char g,unsigned char b){
    rgbRed=r;
    rgbGreen=g;
    rgbBlue = b;
  }
  ~RGBTRIPLE(){
  }
  
};
//RGBA class for BMP Windows format
class RGBQUAD{
 public:
  unsigned char rgbBlue;
  unsigned char rgbGreen;
  unsigned char rgbRed;
  unsigned char rgbReserved;
  RGBQUAD(FILE *fp){
    size_t tmpsize_t = fread(&rgbBlue,1,1,fp);
    tmpsize_t = fread(&rgbGreen,1,1,fp);
    tmpsize_t = fread(&rgbRed,1,1,fp);
    tmpsize_t = fread(&rgbReserved,1,1,fp);
  }
  RGBQUAD(unsigned char r,unsigned char g,unsigned char b,unsigned char rr){
    rgbRed=r;
    rgbGreen=g;
    rgbBlue = b;
    rgbReserved =rr;
  }
  
  
  ~RGBQUAD(){}
  
};
//BMP header class for OS2 12 byte format 
class header12{
 public:
  unsigned long  bcSize;
  short          bcWidth;
  short          bcHeight;
  unsigned short bcPlanes;
  unsigned short bcBitCount;
  RGBTRIPLE **color;
  
  header12(unsigned long OS2orWin,FILE *fp){
    bcSize = OS2orWin;
    size_t tmpsize_t = fread(&bcWidth,2,1,fp);
    tmpsize_t = fread(&bcHeight,2,1,fp);
    tmpsize_t = fread(&bcPlanes,2,1,fp);
    tmpsize_t = fread(&bcBitCount,2,1,fp);
    
    color=NULL;
    int i;
    if(bcBitCount==1){
      color = new RGBTRIPLE* [2];
      for(i=0;i<2;i++){
	color[i] = new RGBTRIPLE(fp);
      }
    }else if(bcBitCount==4){
      color = new RGBTRIPLE* [16];
      for(i=0;i<4;i++){
	color[i] = new RGBTRIPLE(fp);
      }
    }else if(bcBitCount==8){
      color = new RGBTRIPLE* [256];
      for(i=0;i<256;i++){
	color[i] = new RGBTRIPLE(fp);
      }
    }
    
  }
  void print(){
    printf("OS2\n");
    printf("bcWidth = %d\n",bcWidth);
    printf("bcHeight = %d\n",bcHeight);
    printf("bcPlanes = %u\n",bcPlanes);
    printf("bcBitCount = %u\n",bcBitCount);
    
  
  }
  ~header12(){
    if(color!=NULL){
      int i;
      if(bcBitCount==1){
	for(i=0;i<2;i++)delete color[i];
      }else if(bcBitCount==4){
	for(i=0;i<16;i++)delete color[i];
      }else if(bcBitCount==8){
	for(i=0;i<256;i++)delete color[i];
      }
      delete [] color;
    }
  }
};
 //BMP header class Windows Bitmap 40 byte format
class header40{
 public:
  unsigned long  biSize;
  long           biWidth;
  long           biHeight;
  unsigned short biPlanes;
  unsigned short biBitCount;
  unsigned long  biCompression;
  unsigned long  biSizeImage;
  long           biXPixPerMeter;
  long           biYPixPerMeter;
  unsigned long  biClrUsed;
  unsigned long  biClrImporant;
  RGBQUAD **color;
  header40(int sx,int sy){
    biSize = 40;
    biWidth = ((long)(sx));
    biHeight = ((long)(sy));
    //printf("h40: %ld %ld\n",biWidth,biHeight);
    biPlanes = 1;
    biBitCount = 24;
    biCompression = 0;
    long size;
    if (sx % 4 != 0) {
      size = ((sx / 4 + 1) * 4) * sy;
    } else {
      size = sx * sy;
    }
    biSizeImage = size;
    //printf("size = %lu\n",size);
    biXPixPerMeter = 2834;
    biYPixPerMeter = 2834;
    biClrUsed=0;
    biClrImporant=0;
    color=NULL;
  }
  header40(unsigned long OS2orWin,FILE *fp){
    biSize = OS2orWin;
    size_t tmpsize_t = fread(&biWidth,4,1,fp);
    tmpsize_t = fread(&biHeight,4,1,fp);
    tmpsize_t = fread(&biPlanes,2,1,fp);
    tmpsize_t = fread(&biBitCount,2,1,fp);
    tmpsize_t = fread(&biCompression,4,1,fp);
    tmpsize_t = fread(&biSizeImage,4,1,fp);
    tmpsize_t = fread(&biXPixPerMeter,4,1,fp);
    tmpsize_t = fread(&biYPixPerMeter,4,1,fp);
    tmpsize_t = fread(&biClrUsed,4,1,fp);
    tmpsize_t = fread(&biClrImporant,4,1,fp);
    color=NULL;
    int i;
    if(biBitCount==1){
      color = new RGBQUAD* [2];
      for(i=0;i<2;i++){
	color[i] = new RGBQUAD(fp);
      }
    }else if(biBitCount==4){
      color = new RGBQUAD* [16];
      for(i=0;i<4;i++){
	color[i] = new RGBQUAD(fp);
      }
    }else if(biBitCount==8){
      color = new RGBQUAD* [256];
      for(i=0;i<256;i++){
	color[i] = new RGBQUAD(fp);
      }
    }else if(biBitCount==16||biBitCount==24||biBitCount==32){
      if(biClrUsed>0){
	color = new RGBQUAD* [biClrUsed];
	for(i=0;i<biClrUsed;i++){
	  color[i] = new RGBQUAD(fp);
	}
      }
    }

  }
  void write(FILE *fp){
    
    fwrite(&biSize,4,1,fp);
    fwrite(&biWidth,4,1,fp);
    fwrite(&biHeight,4,1,fp);
    fwrite(&biPlanes,2,1,fp);
    fwrite(&biBitCount,2,1,fp);
    fwrite(&biCompression,4,1,fp);
    fwrite(&biSizeImage,4,1,fp);
    fwrite(&biXPixPerMeter,4,1,fp);
    fwrite(&biYPixPerMeter,4,1,fp);
    fwrite(&biClrUsed,4,1,fp);
    fwrite(&biClrImporant,4,1,fp);
    /*
    fwrite(&biSize,sizeof(biSize),1,fp);
    fwrite(&biWidth,sizeof(biWidth),1,fp);
    fwrite(&biHeight,sizeof(biHeight),1,fp);
    fwrite(&biPlanes,sizeof(biPlanes),1,fp);
    fwrite(&biBitCount,sizeof(biBitCount),1,fp);
    fwrite(&biCompression,sizeof(biCompression),1,fp);
    fwrite(&biSizeImage,sizeof(biSizeImage),1,fp);
    fwrite(&biXPixPerMeter,sizeof(biXPixPerMeter),1,fp);
    fwrite(&biYPixPerMeter,sizeof(biYPixPerMeter),1,fp);
    fwrite(&biClrUsed,sizeof(biClrUsed),1,fp);
    fwrite(&biClrImporant,sizeof(biClrImporant),1,fp);
    
    printf("size of : %d  %d\n",(sizeof(biSize)+sizeof(biWidth)+sizeof(biHeight)+sizeof(biPlanes)+sizeof(biBitCount)+sizeof(biCompression)+sizeof(biSizeImage)+sizeof(biXPixPerMeter)+sizeof(biClrUsed)+sizeof(biClrImporant)),(4+4+4+2+2+4+4+4+4+4+4));
    */
  }
  void print(){
    printf("Windows\n");
    printf("biWidth = %ld\n",biWidth);
    printf("biHeight = %ld\n",biHeight);
    printf("biPlanes = %u\n",biPlanes);
    printf("biBitCount = %u\n",biBitCount);
    printf("biCompression = %lu\n",biCompression);
    printf("biSizeImage = %lu\n",biSizeImage);
    printf("biXPixPerMeter = %ld\n",biXPixPerMeter);
    printf("biYPixPerMeter = %ld\n",biYPixPerMeter);
    printf("biClrUsed = %lu\n",biClrUsed);
    printf("biClrImporant = %lu\n",biClrImporant);
  
  }
  ~header40(){
    if(color!=NULL){
      int i;
      if(biBitCount==1){
	for(i=0;i<2;i++)delete color[i];
      }else if(biBitCount==4){
	for(i=0;i<16;i++)delete color[i];
      }else if(biBitCount==8){
	for(i=0;i<256;i++)delete color[i];
      }else if(biBitCount==16||biBitCount==24||biBitCount==32){
	if(biClrUsed>0){
	  
	  for(i=0;i<biClrUsed;i++)delete color[i];
	}
      }
      delete [] color;
    }

  }
  
};
//additional class for BMP Windows 108 and 124 byte format
class CIEXYZ{
 public:
  long ciexyzX;
  long ciexyzY;
  long ciexyzZ;
  CIEXYZ(long x,long y,long z){ciexyzX=x;ciexyzX=y;ciexyzX=z;}
  ~CIEXYZ(){}
  void read(FILE *fp){
    size_t tmpsize_t = fread(&ciexyzX,4,1,fp);
    tmpsize_t = fread(&ciexyzY,4,1,fp);
    tmpsize_t = fread(&ciexyzZ,4,1,fp);
  }
};
//additional class for BMP Windows 108 and 124 byte format
class CIEXYZTRIPLE{
 public:
  CIEXYZ *ciexyzRed;
  CIEXYZ *ciexyzGreen;
  CIEXYZ *ciexyzBlue;
  CIEXYZTRIPLE(){
    ciexyzRed = new CIEXYZ(0,0,0);
    ciexyzGreen = new CIEXYZ(0,0,0);
    ciexyzBlue = new CIEXYZ(0,0,0);
  }
  ~CIEXYZTRIPLE(){
    delete ciexyzRed;
    delete ciexyzGreen;
    delete ciexyzBlue;
    
  }
  void read(FILE *fp){
    ciexyzRed->read(fp);
    ciexyzGreen->read(fp);
    ciexyzBlue->read(fp);
  }
};
//BMP header class for Windows 108 byte format
class header108{
 public:
  unsigned long        bV4Size;
  long         bV4Width;
  long         bV4Height;
  unsigned short         bV4Planes;
  unsigned short         bV4BitCount;
  unsigned long        bV4Compression; 
  unsigned long        bV4SizeImage;
  long         bV4XPelsPerMeter;
  long         bV4YPelsPerMeter;
  unsigned long        bV4ClrUsed;
  unsigned long        bV4ClrImportant;
  unsigned long        bV4RedMask;
  unsigned long        bV4GreenMask;
  unsigned long        bV4BlueMask;
  unsigned long        bV4AlphaMask;
  unsigned long        bV4CSType;
  CIEXYZTRIPLE *bV4Endpoints;
  unsigned long        bV4GammaRed;
  unsigned long        bV4GammaGreen;
  unsigned long        bV4GammaBlue;
  RGBQUAD **color;
  header108(unsigned long OS2orWin,FILE *fp){
    bV4Endpoints = new CIEXYZTRIPLE();
    bV4Size = OS2orWin;
      size_t tmpsize_t = fread(&bV4Width,4,1,fp);
      tmpsize_t = fread(&bV4Height,4,1,fp);
      tmpsize_t = fread(&bV4Planes,2,1,fp);
      tmpsize_t = fread(&bV4BitCount,2,1,fp);
      tmpsize_t = fread(&bV4Compression,4,1,fp); 
      tmpsize_t = fread(&bV4SizeImage,4,1,fp);
      tmpsize_t = fread(&bV4XPelsPerMeter,4,1,fp);
      tmpsize_t = fread(&bV4YPelsPerMeter,4,1,fp);
      tmpsize_t = fread(&bV4ClrUsed,4,1,fp);
      tmpsize_t = fread(&bV4ClrImportant,4,1,fp);
      tmpsize_t = fread(&bV4RedMask,4,1,fp);
      tmpsize_t = fread(&bV4GreenMask,4,1,fp);
      tmpsize_t = fread(&bV4BlueMask,4,1,fp);
      tmpsize_t = fread(&bV4AlphaMask,4,1,fp);
      tmpsize_t = fread(&bV4CSType,4,1,fp);
      bV4Endpoints->read(fp);
      tmpsize_t = fread(&bV4GammaRed,4,1,fp);
      tmpsize_t = fread(&bV4GammaGreen,4,1,fp);
      tmpsize_t = fread(&bV4GammaBlue,4,1,fp);
      color=NULL;
    int i;
    if(bV4BitCount==1){
      color = new RGBQUAD* [2];
      for(i=0;i<2;i++){
	color[i] = new RGBQUAD(fp);
      }
    }else if(bV4BitCount==4){
      color = new RGBQUAD* [16];
      for(i=0;i<4;i++){
	color[i] = new RGBQUAD(fp);
      }
    }else if(bV4BitCount==8){
      color = new RGBQUAD* [256];
      for(i=0;i<256;i++){
	color[i] = new RGBQUAD(fp);
      }
    }else if(bV4BitCount==16||bV4BitCount==24||bV4BitCount==32){
      if(bV4ClrUsed>0){
	color = new RGBQUAD* [bV4ClrUsed];
	for(i=0;i<bV4ClrUsed;i++){
	  color[i] = new RGBQUAD(fp);
	}
      }
    }
  }
  void print(){
    printf("Windows V4\n");
    printf("bV4Width = %ld\n",bV4Width);
    printf("bV4Height = %ld\n",bV4Height);
    printf("bV4Planes = %u\n",bV4Planes);
    printf("bV4BitCount = %u\n",bV4BitCount);
    printf("bV4Compression = %lu\n",bV4Compression);
    printf("bV4SizeImage = %lu\n",bV4SizeImage);
    printf("bV4XPelsPerMeter = %ld\n",bV4XPelsPerMeter);
    printf("bV4YPelsPerMeter = %ld\n",bV4YPelsPerMeter);
    printf("bV4ClrUsed = %lu\n",bV4ClrUsed);
    printf("bV4ClrImportant = %lu\n",bV4ClrImportant);
    printf("bV4RedMask = %lu\n",bV4RedMask);
    printf("bV4GreenMask = %lu\n",bV4GreenMask);
    printf("bV4BlueMask = %lu\n",bV4BlueMask);
    printf("bV4AlphaMask = %lu\n",bV4AlphaMask);
    printf("bV4CSType = %lu\n",bV4CSType);
    printf("bV4GammaRed = %lu\n",bV4GammaRed);
    printf("bV4GammaGreen = %lu\n",bV4GammaGreen);
    printf("bV4GammaBlue = %lu\n",bV4GammaBlue);
  }
  ~header108(){
    delete bV4Endpoints;
    if(color!=NULL){
      int i;
      if(bV4BitCount==1){
	for(i=0;i<2;i++)delete color[i];
      }else if(bV4BitCount==4){
	for(i=0;i<16;i++)delete color[i];
      }else if(bV4BitCount==8){
	for(i=0;i<256;i++)delete color[i];
      }else if(bV4BitCount==16||bV4BitCount==24||bV4BitCount==32){
	if(bV4ClrUsed>0){
	  
	  for(i=0;i<bV4ClrUsed;i++)delete color[i];
	}
      }
      delete [] color;
    }
  }
};
//BMP header class for Windows 124 byte format 
class header124{
 public:
  unsigned long        bV5Size;
  long         bV5Width;
  long         bV5Height;
  unsigned short         bV5Planes;
  unsigned short         bV5BitCount;
  unsigned long        bV5Compression;
  unsigned long        bV5SizeImage;
  long         bV5XPelsPerMeter;
  long         bV5YPelsPerMeter;
  unsigned long        bV5ClrUsed;
  unsigned long        bV5ClrImportant;
  unsigned long        bV5RedMask;
  unsigned long        bV5GreenMask;
  unsigned long        bV5BlueMask;
  unsigned long        bV5AlphaMask;
  unsigned long        bV5CSType;
  CIEXYZTRIPLE *bV5Endpoints;
  unsigned long        bV5GammaRed;
  unsigned long        bV5GammaGreen;
  unsigned long        bV5GammaBlue;
  unsigned long        bV5Intent;
  unsigned long        bV5ProfileData;
  unsigned long        bV5ProfileSize;
  unsigned long        bV5Reserved;
  RGBQUAD **color;
  header124(unsigned long OS2orWin,FILE *fp){
    bV5Endpoints = new CIEXYZTRIPLE();
     bV5Size = OS2orWin;
      size_t tmpsize_t = fread(&bV5Width,4,1,fp);
      tmpsize_t = fread(&bV5Height,4,1,fp);
      tmpsize_t = fread(&bV5Planes,2,1,fp);
      tmpsize_t = fread(&bV5BitCount,2,1,fp);
      tmpsize_t = fread(&bV5Compression,4,1,fp);
      tmpsize_t = fread(&bV5SizeImage,4,1,fp);
      tmpsize_t = fread(&bV5XPelsPerMeter,4,1,fp);
      tmpsize_t = fread(&bV5YPelsPerMeter,4,1,fp);
      tmpsize_t = fread(&bV5ClrUsed,4,1,fp);
      tmpsize_t = fread(&bV5ClrImportant,4,1,fp);
      tmpsize_t = fread(&bV5RedMask,4,1,fp);
      tmpsize_t = fread(&bV5GreenMask,4,1,fp);
      tmpsize_t = fread(&bV5BlueMask,4,1,fp);
      tmpsize_t = fread(&bV5AlphaMask,4,1,fp);
      tmpsize_t = fread(&bV5CSType,4,1,fp);
      bV5Endpoints->read(fp);
      tmpsize_t = fread(&bV5GammaRed,4,1,fp);
      tmpsize_t = fread(&bV5GammaGreen,4,1,fp);
      tmpsize_t = fread(&bV5GammaBlue,4,1,fp);
      tmpsize_t = fread(&bV5Intent,4,1,fp);
      tmpsize_t = fread(&bV5ProfileData,4,1,fp);
      tmpsize_t = fread(&bV5ProfileSize,4,1,fp);
      tmpsize_t = fread(&bV5Reserved,4,1,fp);
      color=NULL;
    int i;
    if(bV5BitCount==1){
      color = new RGBQUAD* [2];
      for(i=0;i<2;i++){
	color[i] = new RGBQUAD(fp);
      }
    }else if(bV5BitCount==4){
      color = new RGBQUAD* [16];
      for(i=0;i<4;i++){
	color[i] = new RGBQUAD(fp);
      }
    }else if(bV5BitCount==8){
      color = new RGBQUAD* [256];
      for(i=0;i<256;i++){
	color[i] = new RGBQUAD(fp);
      }
    }else if(bV5BitCount==16||bV5BitCount==24||bV5BitCount==32){
      if(bV5ClrUsed>0){
	color = new RGBQUAD* [bV5ClrUsed];
	for(i=0;i<bV5ClrUsed;i++){
	  color[i] = new RGBQUAD(fp);
	}
      }
    }
  }
  void print(){
    printf("Windows V5\n");
    printf("bV5Width = %ld\n",bV5Width);
    printf("bV5Height = %ld\n",bV5Height);
    printf("bV5Planes = %u\n",bV5Planes);
    printf("bV5BitCount = %u\n",bV5BitCount);
    printf("bV5Compression = %lu\n",bV5Compression);
    printf("bV5SizeImage = %lu\n",bV5SizeImage);
    printf("bV5XPelsPerMeter = %ld\n",bV5XPelsPerMeter);
    printf("bV5YPelsPerMeter = %ld\n",bV5YPelsPerMeter);
    printf("bV5ClrUsed = %lu\n",bV5ClrUsed);
    printf("bV5ClrImportant = %lu\n",bV5ClrImportant);
    printf("bV5RedMask = %lu\n",bV5RedMask);
    printf("bV5GreenMask = %lu\n",bV5GreenMask);
    printf("bV5BlueMask = %lu\n",bV5BlueMask);
    printf("bV5AlphaMask = %lu\n",bV5AlphaMask);
    printf("bV5CSType = %lu\n",bV5CSType);
    printf("bV5GammaRed = %lu\n",bV5GammaRed);
    printf("bV5GammaGreen = %lu\n",bV5GammaGreen);
    printf("bV5GammaBlue = %lu\n",bV5GammaBlue);
    printf("bV5Intent = %lu\n",bV5Intent);
    printf("bV5ProfileData = %lu\n",bV5ProfileData);
    printf("bV5ProfileSize = %lu\n",bV5ProfileSize);
    printf("bV5Reserved = %lu\n",bV5Reserved);
  }
  ~header124(){
    delete bV5Endpoints;
    if(color!=NULL){
      int i;
      if(bV5BitCount==1){
	for(i=0;i<2;i++)delete color[i];
      }else if(bV5BitCount==4){
	for(i=0;i<16;i++)delete color[i];
      }else if(bV5BitCount==8){
	for(i=0;i<256;i++)delete color[i];
      }else if(bV5BitCount==16||bV5BitCount==24||bV5BitCount==32){
	if(bV5ClrUsed>0){
	  
	  for(i=0;i<bV5ClrUsed;i++)delete color[i];
	}
      }
      delete [] color;
    }
  }
};

//BMP I/O class
class BMPIO{
 public:
  unsigned short bfType;
  unsigned long  bfSize;
  unsigned short bfReserved1;
  unsigned short bfReserved2;
  unsigned long  bfOffBits;
  bool CPUendian;//little is true, big is false
  header12 *h12;
  header40 *h40;
  header108 *h108;
  header124 *h124;
  
  
  BMPIO(){
    bfType=0x4D42;bfReserved1=bfReserved2=0;bfSize=0;bfOffBits=0;
    h12=NULL;h40=NULL;h108=NULL;h124=NULL;CPUendian=true;
  }
  virtual ~BMPIO(){
    if(h12!=NULL)delete h12;
    if(h40!=NULL)delete h40;
    if(h108!=NULL)delete h108;
    if(h124!=NULL)delete h124;
    
  }

  //save R,G,B for bmp format with filename: 24bit no compress, no color palette 
  bool saveBMP(Image *R,Image *G,Image *B,char *filename){
     /* R,G,B should be in 0.0-255.0 8bit*3
       
    */
    if(R==NULL||G==NULL||B==NULL)return false;
    
    if(h12!=NULL)delete h12;h12=NULL;
    if(h40!=NULL)delete h40;h40=NULL;
    if(h108!=NULL)delete h108;h108=NULL;
    if(h124!=NULL)delete h124;h124=NULL;
    h40 = new header40(R->sx,R->sy);
    bfType = 0x4D42;
    long offset=54;
    //long offset = (sizeof(h40->biSize)+sizeof(h40->biWidth)+sizeof(h40->biHeight)+sizeof(h40->biPlanes)+sizeof(h40->biBitCount)+sizeof(h40->biCompression)+sizeof(h40->biSizeImage)+sizeof(h40->biXPixPerMeter)+sizeof(h40->biClrUsed)+sizeof(h40->biClrImporant)+sizeof(bfType)+sizeof(bfSize)+sizeof(bfReserved1)+sizeof(bfReserved2)+sizeof(bfOffBits));
    bfSize = offset+h40->biSizeImage;

    /*
    unsigned long bytesPerPixel = 3;
    unsigned long lineSizeDW = bytesPerPixel * R->sx;
    lineSizeDW = ICEIL(lineSizeDW, sizeof(unsigned long));
    unsigned long lineSize = lineSizeDW * sizeof(unsigned long);
    unsigned long imageSize = lineSize * R->sy;
    printf("imageSize = %lu\n",imageSize);
    */
     

    bfReserved1=0;
    bfReserved2=0;
    bfOffBits = 54;
    //bfOffBits = offset;
    FILE *fp = fopen(filename,"wb");
    if(fp==NULL)return false;
    fwrite(&bfType,2,1,fp);
    fwrite(&bfSize,4,1,fp);
    fwrite(&bfReserved1,2,1,fp);
    fwrite(&bfReserved2,2,1,fp);
    fwrite(&bfOffBits,4,1,fp);
    /*
    fwrite(&bfType,sizeof(bfType),1,fp);
    fwrite(&bfSize,sizeof(bfSize),1,fp);
    fwrite(&bfReserved1,sizeof(bfReserved1),1,fp);
    fwrite(&bfReserved2,sizeof(bfReserved2),1,fp);
    fwrite(&bfOffBits,sizeof(bfOffBits),1,fp);
    */
    h40->write(fp);
    long i, j;
    unsigned char b,g,r;
    
    fseek(fp, offset, SEEK_SET);
    
    for (i = R->sy-1; i >=0; i--) {
      for (j = 0; j < R->sx; j++) {
	b = ((unsigned char)(B->img[i][j]));
	g = ((unsigned char)(G->img[i][j]));
	r = ((unsigned char)(R->img[i][j]));
	fwrite(&b,1, 1, fp);
	fwrite(&g,1, 1, fp);
	fwrite(&r,1, 1, fp);
	
      }
      
      if ((R->sx % 4) != 0) {
	//for (j = 0; j < ((R->sx / 4 + 1) * 4)- R->sx; j++) {
	for (j = 0; j < (R->sx % 4); j++) {
	unsigned char zero = 0;
	  fwrite(&zero,1, 1, fp);
	}
      }
    }
    
    fclose(fp);
    delete h40;h40=NULL;
    return true;
  }

  //save Grayscale for bmp format with filename: 24bit no compress, no color palette 
  bool saveBMP(Image *Gray,char *filename){
     /* Gray should be in 0.0-255.0 8bit*3
       
    */
    if(Gray==NULL)return false;
    
    if(h12!=NULL)delete h12;h12=NULL;
    if(h40!=NULL)delete h40;h40=NULL;
    if(h108!=NULL)delete h108;h108=NULL;
    if(h124!=NULL)delete h124;h124=NULL;
    h40 = new header40(Gray->sx,Gray->sy);
    bfType = 0x4D42;
    long offset=54;
    bfSize = offset+h40->biSizeImage;
    bfReserved1=0;
    bfReserved2=0;
    bfOffBits = 54;
    FILE *fp = fopen(filename,"wb");
    if(fp==NULL)return false;
    fwrite(&bfType,2,1,fp);
    fwrite(&bfSize,4,1,fp);
    fwrite(&bfReserved1,2,1,fp);
    fwrite(&bfReserved2,2,1,fp);
    fwrite(&bfOffBits,4,1,fp);
    h40->write(fp);
    long i, j;
    unsigned char b,g,r;
    
    fseek(fp, offset, SEEK_SET);
    
    for (i = Gray->sy-1; i >=0; i--) {
      for (j = 0; j < Gray->sx; j++) {
	b = ((unsigned char)(Gray->img[i][j]));
	g = ((unsigned char)(Gray->img[i][j]));
	r = ((unsigned char)(Gray->img[i][j]));
	fwrite(&b,1, 1, fp);
	fwrite(&g,1, 1, fp);
	fwrite(&r,1, 1, fp);
	
      }
      
      if ((Gray->sx % 4) != 0) {
	//for (j = 0; j < ((Gray->sx / 4 + 1) * 4) - Gray->sx; j++) {
	for (j = 0; j < (Gray->sx % 4); j++) {
	unsigned char zero = 0;
	  fwrite(&zero,1, 1, fp);
	}
      }
    }
    
    fclose(fp);
    delete h40;h40=NULL;
    return true;
  }

 private:
  //read image data to R,G,B with OS2 format
  void readBMP(FILE * bmp,Image *R,Image *G,Image *B,
	       long offset,
	       long width,
	       long sy,
	       short bits,
	       RGBQUAD **color,unsigned long  biCompression,unsigned long RedMask, unsigned long GreenMask, unsigned long BlueMask){
    int r, g, b, alpha;
    long i, j, line, position, count = 0;
    line = (width * bits) / 8;
    if ((line % 4) != 0) {
      line = ((line / 4) + 1) * 4;
    }
    long height = labs(sy);
    if(sy>0){
      for (i = 0; i < height; i++) {
        position = offset + line * (height - (i + 1));
	fseek(bmp, position, SEEK_SET);
	
	for (j = 0; j < width; j++) {
	  if (bits == 32) {
	    if(biCompression==0){
	      b = fgetc(bmp);
	      g = fgetc(bmp);
	      r = fgetc(bmp);
	      alpha = fgetc(bmp);
	      
	      R->img[i][j]=((double)(r));
	      G->img[i][j]=((double)(g));
	      B->img[i][j]=((double)(b));
	    }else if(biCompression==3){
	      unsigned long buf;
	      size_t tmpsize_t = fread(&buf,4,1,bmp);
	      
	      R->img[i][j]=((double)((buf & RedMask)>>16));
	      G->img[i][j]=((double)((buf & GreenMask)>>8));
	      B->img[i][j]=((double)((buf & BlueMask)));
	      //printf("%lf %lf %lf\n",R->img[i][j],G->img[i][j],B->img[i][j]);
	    }
	    count++;
	  }else if (bits == 24) {
	    b = fgetc(bmp);
	    g = fgetc(bmp);
	    r = fgetc(bmp);
	    
	    R->img[i][j]=((double)(r));
	    G->img[i][j]=((double)(g));
	    B->img[i][j]=((double)(b));
	    
	    count++;
	  }else if (bits == 8) {
	    int index;
	    
	    index = fgetc(bmp);
	    R->img[i][j]=((double)(color[index]->rgbRed));
	    G->img[i][j]=((double)(color[index]->rgbGreen));
	    B->img[i][j]=((double)(color[index]->rgbBlue));
	    
	    count++;
	  }
	}
      }
    }else{
       for (i = 0; i < height; i++) {
        position = offset + line * (height - (i + 1));
	fseek(bmp, position, SEEK_SET);
	
	for (j = 0; j < width; j++) {
	  if (bits == 32) {
	    if(biCompression==0){
	      b = fgetc(bmp);
	      g = fgetc(bmp);
	      r = fgetc(bmp);
	      alpha = fgetc(bmp);
	      
	      R->img[(height-1-i)][j]=((double)(r));
	      G->img[(height-1-i)][j]=((double)(g));
	      B->img[(height-1-i)][j]=((double)(b));
	    }else if(biCompression==3){
	      unsigned long buf;
	      size_t tmpsize_t = fread(&buf,4,1,bmp);
	      R->img[(height-1-i)][j]=((double)((buf & RedMask)>>16));
	      G->img[(height-1-i)][j]=((double)((buf & GreenMask)>>8));
	      B->img[(height-1-i)][j]=((double)((buf & BlueMask)));
	    }
	    count++;
	  }else if (bits == 24) {
	    b = fgetc(bmp);
	    g = fgetc(bmp);
	    r = fgetc(bmp);
	    
	    R->img[(height-1-i)][j]=((double)(r));
	    G->img[(height-1-i)][j]=((double)(g));
	    B->img[(height-1-i)][j]=((double)(b));
	    
	    count++;
	  }else if (bits == 8) {
	    int index;
	    
	    index = fgetc(bmp);
	    R->img[(height-1-i)][j]=((double)(color[index]->rgbRed));
	    G->img[(height-1-i)][j]=((double)(color[index]->rgbGreen));
	    B->img[(height-1-i)][j]=((double)(color[index]->rgbBlue));
	    
	    count++;
	  }
	}
      }
      
    }
    
  }
  //read image data to R,G,B with BMP Windows format
  void readBMP(FILE * bmp,Image *R,Image *G,Image *B,
	       long offset,
	       long width,
	       long sy,
	       short bits,
	       RGBTRIPLE **color){
    int r, g, b, alpha;
    long i, j, line, position, count = 0;
    line = (width * bits) / 8;
    if ((line % 4) != 0) {
      line = ((line / 4) + 1) * 4;
    }
    long height = labs(sy);
    if(sy>0){
      for (i = 0; i < height; i++) {
        position = offset + line * (height - (i + 1));
	fseek(bmp, position, SEEK_SET);
	
	for (j = 0; j < width; j++) {
	  if (bits == 32) {
	    
	    b = fgetc(bmp);
	    g = fgetc(bmp);
	    r = fgetc(bmp);
	    alpha = fgetc(bmp);
	    
	    R->img[i][j]=((double)(r));
	    G->img[i][j]=((double)(g));
	    B->img[i][j]=((double)(b));
	    
	    count++;
	  }else if (bits == 24) {
	    b = fgetc(bmp);
	    g = fgetc(bmp);
	    r = fgetc(bmp);
	    
	    R->img[i][j]=((double)(r));
	    G->img[i][j]=((double)(g));
	    B->img[i][j]=((double)(b));
	    
	    count++;
	  }else if (bits == 8) {
	    int index;
	    
	    index = fgetc(bmp);
	    R->img[i][j]=((double)(color[index]->rgbRed));
	    G->img[i][j]=((double)(color[index]->rgbGreen));
	    B->img[i][j]=((double)(color[index]->rgbBlue));
	    
	    count++;
	  }
	}
      }
    }else{
       for (i = 0; i < height; i++) {
        position = offset + line * (height - (i + 1));
	fseek(bmp, position, SEEK_SET);
	
	for (j = 0; j < width; j++) {
	  if (bits == 32) {
	 
	      b = fgetc(bmp);
	      g = fgetc(bmp);
	      r = fgetc(bmp);
	      alpha = fgetc(bmp);
	      
	      R->img[(height-1-i)][j]=((double)(r));
	      G->img[(height-1-i)][j]=((double)(g));
	      B->img[(height-1-i)][j]=((double)(b));
	 
	    count++;
	  }else if (bits == 24) {
	    b = fgetc(bmp);
	    g = fgetc(bmp);
	    r = fgetc(bmp);
	    
	    R->img[(height-1-i)][j]=((double)(r));
	    G->img[(height-1-i)][j]=((double)(g));
	    B->img[(height-1-i)][j]=((double)(b));
	    
	    count++;
	  }else if (bits == 8) {
	    int index;
	    
	    index = fgetc(bmp);
	    R->img[(height-1-i)][j]=((double)(color[index]->rgbRed));
	    G->img[(height-1-i)][j]=((double)(color[index]->rgbGreen));
	    B->img[(height-1-i)][j]=((double)(color[index]->rgbBlue));
	    
	    count++;
	  }
	}
      }
      
    }
    
  }
 public:
  //get BMP image size from filename
  bool readBMPSize(int *sx,int *sy,char *filename){
    unsigned long OS2orWin;
    FILE *fp = fopen(filename,"rb");
    if(fp==NULL)return false;
    
    size_t tmpsize_t = fread(&bfType,2,1,fp);
    tmpsize_t = fread(&bfSize,4,1,fp);
    tmpsize_t = fread(&bfReserved1,2,1,fp);
    tmpsize_t = fread(&bfReserved2,2,1,fp);
    tmpsize_t = fread(&bfOffBits,4,1,fp);
    tmpsize_t = fread(&OS2orWin,4,1,fp);
    /*
    printf("bfType = %u\n",bfType);
    printf("bfSize = %lu\n",bfSize);
    printf("bfReserved1 = %u\n",bfReserved1);
    printf("bfReserved2 = %u\n",bfReserved2);
    printf("bfOffBits = %lu\n",bfOffBits);
    printf("OS2orWin = %lu\n",OS2orWin);
    */
    
    long           biWidth;
     long           biHeight;
    if(OS2orWin==12){
      short          bcWidth;
      short          bcHeight;
      tmpsize_t = fread(&bcWidth,2,1,fp);
      tmpsize_t = fread(&bcHeight,2,1,fp);
      (*sx)=((int)(bcWidth));
      (*sy)=((int)(abs(((int)(bcHeight)))));
    }else if(OS2orWin==40){
     
      tmpsize_t = fread(&biWidth,4,1,fp);
      tmpsize_t = fread(&biHeight,4,1,fp);
      //printf("%ld %ld\n",biWidth,biHeight);
      (*sx)=((int)(biWidth));
      (*sy)=((int)(labs(biHeight)));
      delete h40;
    }else if(OS2orWin==108){
      tmpsize_t = fread(&biWidth,4,1,fp);
      tmpsize_t = fread(&biHeight,4,1,fp);
      (*sx)=((int)(biWidth));
      (*sy)=((int)(labs(biHeight)));
    }else if(OS2orWin==124){
      tmpsize_t = fread(&biWidth,4,1,fp);
      tmpsize_t = fread(&biHeight,4,1,fp);
      (*sx)=((int)(biWidth));
      (*sy)=((int)(labs(biHeight)));      
    }else{ 
      fclose(fp);
      return false;
    }
    fclose(fp);
    return true;
  }
  //get BMP image to R,G,B from filename
  bool readBMP(Image *R,Image *G,Image *B,char *filename){
    if(R==NULL||G==NULL||B==NULL){
      printf("R,G,B should be allocated !\n");
      return false;
      
    }
    unsigned long OS2orWin;
    FILE *fp = fopen(filename,"rb");
    if(fp==NULL)return false;
    
    size_t tmpsize_t = fread(&bfType,2,1,fp);
    
    if(bfType!=0x4D42){
      if(bfType!=0x424D){
	printf("The file is not BMP format !\n");
	fclose(fp);
	return false;
      }else{
	printf("BMP BigEndian file is currently not supported !\n");
	fclose(fp);
	return false;
	CPUendian=false;
      }
    }else{
      CPUendian=true;
    }
    tmpsize_t = fread(&bfSize,4,1,fp);
    tmpsize_t = fread(&bfReserved1,2,1,fp);
    tmpsize_t = fread(&bfReserved2,2,1,fp);
    tmpsize_t = fread(&bfOffBits,4,1,fp);
    tmpsize_t = fread(&OS2orWin,4,1,fp);
    
    if(OS2orWin==12){
      h12 = new header12(OS2orWin,fp);
      //print header for debug
      //h12->print();
      
      if(!(h12->bcBitCount==8||h12->bcBitCount==24||h12->bcBitCount==32)){
	printf("BMP BitCount = %d is not supported !\n",h12->bcBitCount);
	fclose(fp);
	return false;
      }
  
      readBMP(fp,R,G,B,bfOffBits,h12->bcWidth,h12->bcHeight,h12->bcBitCount,h12->color);
    }else if(OS2orWin==40){
      h40 = new header40(OS2orWin,fp);
      //print header for debug
      //h40->print();
      
      if(h40->biCompression!=0){
	printf("BMP compression is not supported !\n");
	fclose(fp);
	return false;
      }
      if(!(h40->biBitCount==8||h40->biBitCount==24||h40->biBitCount==32)){
	printf("BMP BitCount = %d is not supported !\n",h40->biBitCount);
	fclose(fp);
	return false;
      }
      if((h40->biBitCount==24||h40->biBitCount==32)&&h40->biClrUsed!=0){
	printf("BMP BitCount = %lu and biClrUsed is not supported !\n",h40->biClrUsed);
	fclose(fp);
	return false;
      }
      
      
      readBMP(fp,R,G,B,bfOffBits,h40->biWidth,h40->biHeight,h40->biBitCount,h40->color,h40->biCompression,0,0,0);
      
    }else if(OS2orWin==108){
      h108 = new header108(OS2orWin,fp);
      //print header for debug
      //h108->print();

      if(!(h108->bV4Compression==0||h108->bV4Compression==3)){
	printf("BMP compression is not supported !\n");
	fclose(fp);
	return false;
      }
      if(!(h108->bV4BitCount==8||h108->bV4BitCount==24||h108->bV4BitCount==32)){
	printf("BMP BitCount = %d is not supported !\n",h108->bV4BitCount);
	fclose(fp);
	return false;
      }
      if((h108->bV4BitCount==24||h108->bV4BitCount==32)&&h108->bV4ClrUsed!=0){
	printf("BMP BitCount = %lu and bV4ClrUsed is not supported !\n",h108->bV4ClrUsed);
	fclose(fp);
	return false;
      }
      
      
      readBMP(fp,R,G,B,bfOffBits,h108->bV4Width,h108->bV4Height,h108->bV4BitCount,h108->color,h108->bV4Compression,h108->bV4RedMask,h108->bV4GreenMask,h108->bV4BlueMask);
      

    }else if(OS2orWin==124){
      h124 = new header124(OS2orWin,fp);
      //print header for debug
      //h124->print();

      if(!(h124->bV5Compression==0||h124->bV5Compression==3)){
	printf("BMP compression is not supported !\n");
	fclose(fp);
	return false;
      }
      if(!(h124->bV5BitCount==8||h124->bV5BitCount==24||h124->bV5BitCount==32)){
	printf("BMP BitCount = %d is not supported !\n",h124->bV5BitCount);
	fclose(fp);
	return false;
      }
      if((h124->bV5BitCount==24||h124->bV5BitCount==32)&&h124->bV5ClrUsed!=0){
	printf("BMP BitCount = %lu and biClrUsed is not supported !\n",h124->bV5ClrUsed);
	fclose(fp);
	return false;
      }
      
      readBMP(fp,R,G,B,bfOffBits,h124->bV5Width,h124->bV5Height,h124->bV5BitCount,h108->color,h124->bV5Compression,h124->bV5RedMask,h124->bV5GreenMask,h124->bV5BlueMask);
      
      
    }else{ 
      fclose(fp);
      return false;
    }
    fclose(fp);
    return true;
  }

};

#undef ICEIL
