#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h" /* 画像クラス */
#include"BMPIO.h" /* BMP画像の入出力関数 stdlib.hが必要 */

/* 正規化用の関数 */
void Normalize(Image *R,Image *G,Image *B){
  double max,min;
  max= min = R->img[0][0];
  int i,j;
  
  for(i=0;i<R->sy;i++)
    for(j=0;j<R->sx;j++){
      if(max<R->img[i][j])max=R->img[i][j];
      if(max<G->img[i][j])max=G->img[i][j];
      if(max<B->img[i][j])max=B->img[i][j];
      if(min>R->img[i][j])min=R->img[i][j];
      if(min>G->img[i][j])min=G->img[i][j];
      if(min>B->img[i][j])min=B->img[i][j];
    }
  double range = fabs(max-min);if(range<=0.0)range=1.0;
   
  for(i=0;i<R->sy;i++)
     for(j=0;j<R->sx;j++){
       double val = 255.0*(R->img[i][j]-min)/range;if(val<0.0)val=0.0;if(val>255.0)val=255.0;
      R->img[i][j] = val;
      val = 255.0*(G->img[i][j]-min)/range;if(val<0.0)val=0.0;if(val>255.0)val=255.0;
      G->img[i][j] = val;
      val = 255.0*(B->img[i][j]-min)/range;if(val<0.0)val=0.0;if(val>255.0)val=255.0;
      B->img[i][j] = val;
     }
     
}
/* 黒白反転の関数 */
void Negative(Image *R,Image *G,Image *B){
  int i,j;
  for(i=0;i<R->sy;i++)
     for(j=0;j<R->sx;j++){
       R->img[i][j] = 255.0-R->img[i][j];
       G->img[i][j] = 255.0-G->img[i][j];
       B->img[i][j] = 255.0-B->img[i][j];
       
     }
}

/* BMP画像を読み込んでグレースケールの勾配強度をSobel作用素にて計算しBMP画像として保存する 
コンパイル: g++ -o EdgeMagnitude EdgeMagnitude.cxx -lm
実行： ./EdgeMagnitude 入力BMP 出力BMP 
引数２
*/
int main(int argc,char *argv[]){
  
  
  /* 画像クラスImageを用いて入力画像のカラー用にR,G,Bを宣言する */
  
  

  /* 画像サイズ */
  int sx,sy;

  
  /* BMPIOクラスを宣言しnewする */
  
  /* BMPIOクラスのreadBMPSize()を使って、argv[1]で与えられたファイル名でsx,syに画像サイズを入れる */
  
  
  /* sx,syでR,G,Bのメモリを確保する(new する) */
  

  /* BMPIOクラスのreadBMP()を使ってargv[1]で与えられるファイル名の画像をR,G,Bに読み込む */
  
  /* グレースケール画像用にImageクラスをgrayとして宣言しsx,syのサイズでメモリを確保する */
   Image *gray = new Image(sx,sy);
  int i,j;
  /* 各画素をたどるループ */  
  for(i=0;i<sy;i++)
    for(j=0;j<sx;j++){
      /* R,G,B値の平均をgrayに代入する */
    }
  

  /* 出力画像用にImageクラスをoutR,outG,outBとして宣言しsx,syのサイズでメモリを確保する */

   
 
  /* Sobel作用素用の3x3画像をx方向(sobelX)、y方向(sobelY)の二つ宣言しメモリを確保する */
   Image *sobelX = new Image(3,3);
  Image *sobelY = new Image(3,3);
  
  /* Sobel作用素用画像を作成する */
  sobelX->img[0][0] = -1.0;
  sobelX->img[0][1] = 0.0;
  sobelX->img[0][2] = 1.0;
  sobelX->img[1][0] = -2.0;
  sobelX->img[1][1] = 0.0;
  sobelX->img[1][2] = 2.0;
  sobelX->img[2][0] = -1.0;
  sobelX->img[2][1] = 0.0;
  sobelX->img[2][2] = 1.0;
  
  sobelY->img[0][0] = -1.0;
  sobelY->img[0][1] = -2.0;
  sobelY->img[0][2] = -1.0;
  sobelY->img[1][0] = 0.0;
  sobelY->img[1][1] = 0.0;
  sobelY->img[1][2] = 0.0;
  sobelY->img[2][0] = 1.0;
  sobelY->img[2][1] = 2.0;
  sobelY->img[2][2] = 1.0; 

   
  

  /* 勾配強度計算ここから */
  
  /* 各画素をたどるループ 
     注意点：端の勾配は計算しなくてよい

   */  
  for(i=1;i<sy-1;i++)
    for(j=1;j<sx-1;j++){
      /* X方向の微分値とY方向の微分値を足し合わせるための変数を二つ用意し、ゼロを代入する */
      double dx=0.0;
      double dy=0.0;
      
      int l,m;
       /* 3x3の局所Window内をたどるループ */  
      for(l=-1;l<=1;l++)
	for(m=-1;m<=1;m++){
	  /* 画素の座標[i+l][j+m]のgray値と、座標[l+1][m+1]のsobelX,sobelYの値をかけて、それぞれdx,dyへ足し合わせる */
	  
	}
      /* 勾配強度を計算 */
      double grad_magnitude = sqrt(dx*dx+dy*dy);

      /* 出力のoutR,outG,outBへ勾配強度grad_magnitudeを代入 */
      
      
    }
  

  /* 勾配強度計算ここまで */
  /* outR,outG,outBを0-255へ線形補間で正規化する */
  Normalize(outR,outG,outB);
/* 黒白反転する */
  Negative(outR,outG,outB);


  /* BMPIOクラスのsaveBMP()を使ってargv[2]で与えられるファイル名にoutR,outG,outBの画像を保存する */
  

  
  /* BMPIOクラスのメモリを開放する(deleteする) */
  

  /* R,G,Bのメモリを開放する(deleteする) */
  
  
  /* outR,outG,outBのメモリを開放する(deleteする) */
  
  /* gray,sobelX,sobelYのメモリを開放する(deleteする) */
   delete gray;
  delete sobelX;
  delete sobelY;

  return 0;
}
